<?php

namespace App\Nova;

use App\Nova\Resources\Branch\Branch;
use App\Nova\Resources\System\Roles\Role;
use Illuminate\Http\Request;
use Illuminate\Validation\Rules;
use Laravel\Nova\Fields\BelongsToMany;
use Laravel\Nova\Fields\ID;
use Laravel\Nova\Fields\MorphToMany;
use Laravel\Nova\Fields\Password;
use Laravel\Nova\Fields\Text;
use Laravel\Nova\Http\Requests\NovaRequest;
use Nurmuhammet\NovaInputmask\NovaInputmask;
use Trin4ik\NovaSwitcher\NovaSwitcher;

class User extends Resource
{
    /**
     * The model the resource corresponds to.
     *
     * @var class-string<\App\Models\User>
     */
    public static $model = \App\Models\User::class;

    /**
     * The single value that should be used to represent the resource when being displayed.
     *
     * @var string
     */
    public static $title = 'name';

    /**
     * The columns that should be searched.
     *
     * @var array
     */
    public static $search = [
        'id', 'name', 'email',
    ];

    /**
     * Build an "index" query for the given resource.
     *
     * @param  \Illuminate\Database\Eloquent\Builder  $query
     * @return \Illuminate\Database\Eloquent\Builder
     */
    public static function indexQuery(NovaRequest $request, $query)
    {
        // $query->where('email', '!=', 'nurmuhammet@mail.com')
        //     ->where('email', '!=', 'mahmyt1206@gmail.com');

        return $query;
    }

    /**
     * Get the displayable label of the resource.
     */
    public static function label(): string
    {
        return __('Users');
    }

    /**
     * Get the displayable singular label of the resource.
     */
    public static function singularLabel(): string
    {
        return __('User');
    }

    /**
     * Get the fields displayed by the resource.
     */
    public function fields(NovaRequest $request): array
    {
        return [
            ID::make()->sortable(),

            Text::make(__('Username'), 'username')
                ->sortable()
                ->rules('required', 'string', 'alpha_dash:ascii', 'max:250')
                ->creationRules('unique:users,username')
                ->updateRules('unique:users,username,{{resourceId}}'),

            Text::make(__('Name'), 'name')
                ->sortable()
                ->rules('required', 'max:255'),

            NovaInputmask::make(__('Phone'), 'phone')
                ->mask('+(\\9\\93)-99-99-99-99')
                ->storeRawValue()
                ->rules('nullable', 'integer', 'between:61000000, 71999999'),

            Text::make(__('Email'), 'email')
                ->sortable()
                ->rules('nullable', 'email', 'max:254')
                ->creationRules('unique:users,email')
                ->updateRules('unique:users,email,{{resourceId}}'),

            Password::make(__('Password'), 'password')
                ->onlyOnForms()
                ->creationRules('required', Rules\Password::defaults())
                ->updateRules('nullable', Rules\Password::defaults()),

            NovaSwitcher::make(__('Active'), 'active')
                ->default(true)
                ->canSeeWhen('isAdmin', $this),

            MorphToMany::make(__('Roles'), 'roles', Role::class)
                ->canSeeWhen('isAdmin', $this),

            BelongsToMany::make(__('Branches'), 'branches', Branch::class)
                ->canSeeWhen('isAdmin', $this),
        ];
    }

    /**
     * Get the cards available for the request.
     *
     * @return array
     */
    public function cards(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the filters available for the resource.
     *
     * @return array
     */
    public function filters(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the lenses available for the resource.
     *
     * @return array
     */
    public function lenses(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the actions available for the resource.
     *
     * @return array
     */
    public function actions(NovaRequest $request)
    {
        return [];
    }
}
